*
      SUBROUTINE PAR_GEEV1(N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)
*           
*     PDGEEV1
*
*  
      INTEGER            N, NPROCS, MMIN, NB, NPROW, NPCOL
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6)
*
*  
      INTEGER            INFO, HBL, I, IPA, IPWE, IPWI,
     $                   IPW, IPWOR, ILO, IHI, ILOZ, IHIZ,
     $                   IIA, JJ, IAROW, IACOL, IHIP, IOFF,
     $                   ILROW, IHLP, ILCOL, INLQ, LOCALK,
     $                   LDA, IAFIRST, JAFIRST, LCMRC,
     $                   NB0, NP, NQ, M, MXLLDA,
     $                   MYCOL, MYROW, MXNP, MXNQ,
     $                   LWMIN, LWORK, LWORK1,
     $                   WORKSIZ
*
      INTEGER            DESCA(9)
*
*  
      INTEGER            ILCM, NUMROC, INDXG2P
      EXTERNAL           ILCM, NUMROC, INDXG2P
*
*  
      EXTERNAL           INFOG2L

*  
      INTRINSIC          DBLE, MAX, MOD, SQRT, INT, REAL
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      IF( NPROW .NE. 0 .AND. NPCOL .NE. 0 ) GO TO 1
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
*
    1 CONTINUE
*
      IF( NB .NE. 0 ) GO TO 2
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
*
      IF( NB0.GE.2 .AND. NB0.LE.8 ) NB = 8
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 ) NB = 32
*
*   BLACS'   
*
    2 CONTINUE
*
      DESCA(1) = 1
      DESCA(4) = N
      DESCA(5) = NB
      DESCA(6) = NB
      DESCA(7) = 0
      DESCA(8) = 0
*
      MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      DESCA(9) = MXNP
      MXLLDA = MXNP
*
*     A
      IPA = 1
*
*     WE (  
* )
      IPWE = IPA + MXLLDA*MXNQ
*
*     WI (   )
      IPWI = IPWE + N
*
*     WORK
      IPWOR = IPWI + N
*     W
*
*
**      ILO = 1
**      IHI = N
**      ILOZ = 1
**      IHIZ = N
*
            CALL INFOG2L( 1, 1, DESCA, NPROW, NPCOL, 0, 0,
     $                    IIA, JJA, IAROW, IACOL )
            IHIP = NUMROC( N, NB, 0, IAROW, NPROW )
            IOFF = MOD( 0, NB )
            ILROW = INDXG2P( 1, NB, 0, 0, NPROW )
            IHLP = NUMROC( N+IOFF, NB, 0, ILROW, NPROW )
            ILCOL = INDXG2P( 1, NB, 0, 0, NPCOL )
            INLQ = NUMROC( N+IOFF, NB, 0, ILCOL, NPCOL )
            LWMIN = NB*( NB + MAX( IHIP+1, IHLP+INLQ ) )
*
            LWORK  = LWMIN
*
*   ,    PDGEEV1
*
      HBL = DESCA( 6 )
      LDA = DESCA( 9 )
      IAFIRST = DESCA( 7 )
      JAFIRST = DESCA( 8 )
      LCMRC = ILCM( NPROW, NPCOL )
*
*    ,    
*  
*
      LOCALK = NUMROC( N, N, 0, 0, NPCOL )
      JJ = 1
      IF( JJ*HBL.LT.N )
     $   JJ = JJ + 1
      JJ = 7*JJ / LCMRC
      LWORK1 = 3*N+MAX( 2*LDA + 2*LOCALK, JJ )
*
        IF( LWORK .LT. LWORK1 ) THEN
           LWORK = LWORK1
        END IF
*
      IPW = IPWOR + LWORK
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
        WRITE( NPR, FMT = 9992 )
        WRITE( NPR, FMT = 9998 )N, N, NPROCS
        WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
        WRITE( NPR, FMT = 9993 )NB, NB
*
         WRITE( NPR, FMT = * )'  IPA,  IPWE, IPWI, IPWOR,  IPW, MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPWE, IPWI, IPWOR, IPW, MMIN
*
         WRITE( NPR, FMT = 9994 )LWMIN, LWORK, LWORK1
*
 9994 FORMAT( / 7I9 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '    ',
     $      '     PDGEEV1 ')
*
 9998 FORMAT( /'      A ',I5,' *',I5,',',
     $       '    ',I3 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I9,'  '/)
 9993 FORMAT( / '       NB ',
     $       I3,' *',I3 // '     '/)
      RETURN
      END
